stages:
  - build
  - test

variables:
  IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_PROJECT_PATH:$CI_COMMIT_REF_SLUG

build:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t microservice .
    - docker run -d -p 8080:8080 microservice
    - docker ps -a
  only:
    - main
    - merge_requests

test:
  stage: test
  image: rust:latest
  script:
    - cargo test --verbose
  only:
    - main
    - merge_requests